
 include "doorsos.h"
 include "userlib.h"
 include "graphlib.h"
 include "ziplib.h"
 xdef _main
 xdef _comment
 xdef _ti89
;***************************************;
npix       equ 2
bas_balle  equ 10
bonus_time equ 500
;***************************************;

_main:
 move.l  #difftabHW1,a0
 move.l  a0,difftab
 move.b  HW_VERSION,d0
 cmp.b   #1,d0
 beq     SkipHW2Speed
 move.l  #difftabHW2,a0
 move.l  a0,difftab
SkipHW2Speed:

 jsr graphlib::clr_scr
 move.w  #2,-(a7) ;grandes fontes
 jsr     doorsos::FontSetSys
 lea     2(a7),a7
 lea     titre(PC),a4
 WriteStrA #0,#0,#0,a4
 move.w  #0,-(a7) ;petites fontes
 jsr     doorsos::FontSetSys
 lea     2(a7),a7
 lea     t1(PC),a4
 WriteStrA #0,#13,#4,a4
 lea     t2(PC),a4
 WriteStrA #0,#35,#4,a4
 lea     t3(PC),a4
 WriteStrA #0,#43,#4,a4
 lea     t4(PC),a4
 WriteStrA #0,#53,#4,a4
 lea     t5(PC),a4
 WriteStrA #0,#61,#4,a4
 lea     t7(PC),a4
 WriteStrA #0,#81,#4,a4

 jsr     userlib::idle_loop


 move.l  #2200,-(a7) ;place pour \Gamma\cran virtuel
 jsr     doorsos::HeapAllocThrow
 lea     4(a7),a7
 move.w  d0,hnum
 doorsos::DEREF d0,a0
 move.l  a0,hptr

 clr.w   score
Menu:
 move.w  #1,-(a7);fontes L6*H8
 jsr     doorsos::FontSetSys
 lea     2(a7),a7
 jsr     graphlib::clr_scr
 lea     title(PC),a0
 move.l  hptr,a1
 jsr     ziplib::extract
 lea     LCD_MEM,a0
 move.w  #49,d0
Rep1:
 move.w  #19,d1
Rep2:
 move.b  (a1)+,(a0)+
 dbra    d1,Rep2
 lea     10(a0),a0
 dbra    d0,Rep1

 tst.w   score ;un score \Delta\ la derni?re partie ?
 beq     MenuLoop
 bsr     ArchiveScore ;oui=>on archive nom et score du joueur
MenuLoop:
 bsr     ShowScores
 bsr     ShowDiff
 jsr     userlib::idle_loop
 cmp.w   #338,d0;diff-1
 bne     NoDecDiff
 tst.w   diff
 beq     NoDecDiff
 sub.w   #1,diff
NoDecDiff:
 cmp.w   #344,d0;diff+1
 bne     NoIncDiff
 cmp.w   #4,diff
 beq     NoIncDiff
 add.w   #1,diff
NoIncDiff:
 cmp.w   #264,d0
 beq     Exit ;esc=>quitter
 cmp.w   #13,d0 ;enter=>d\Gamma\but de partie
 bne     MenuLoop


 move.w  diff,d0
 lsl.w   #1,d0
 move.l  difftab,a0
 move.b  0(a0,d0),delay
 move.b  1(a0,d0),nholes
 move.w  #2*npix,vpix
 move.w  #npix,hpix


 move.w  #$0700,d0            ;int#1
 trap    #1
 move.l  $64,oldint#1
 move.l  $60+6*4,oldint#6     ;and int#6 [ON]
 bclr.b  #2,$600001
 move.l  #newint#1,$64
 move.l  #newint#6,$60+6*4    
 bset.b  #2,$600001
 trap    #1


 lea     matrix(PC),a0 ;nettoie la matrice
 move.w  #54,d0
\clr:
 clr.w   (a0)+
 dbra    d0,\clr

 move.l  hptr,a0 ;on copie \Gamma\cran vers handle
 lea     LCD_MEM,a1
 move.w  #99,d0
InitHandle1:
 move.w  #9,d1
InitHandle2:
 move.w  (a1)+,(a0)+
 dbra    d1,InitHandle2
 lea     10(a1),a1 ;putain de ti89 de merde !
 dbra    d0,InitHandle1
 move.w  #10*10-1,d1
InitHandle3:
 clr.w   (a0)+
 dbra    d1,InitHandle3

 move.w  #75,x
 clr.w   y
 clr.w   score
 clr.w   freqfloor ;freqfloor : un mur toutes les 3 lignes
 clr.w   dy

MainBoucle:
 bsr     GetKeyStat
 btst.b  #0,keystat+6
 bne     NoDone
DepressLoop:
 bsr     GetKeyStat
 btst.b  #0,keystat+6
 beq     DepressLoop
 bra     Done

NoDone:
 add.w   #npix,dy ;d\Gamma\calage ecran/handle (0-9)
 add.w   #npix,y ;balle
 cmp.w   #10,dy ;d\Gamma\calage=10 ?
 blt     NoNewMatrixLine
 sub.w   #10,dy ;oui=>scrolle matrice+handle d'une ligne (=10pixels)
 sub.w   #10,y ;coord y balle -10
 bsr     ScrollUp
NoNewMatrixLine:
 bsr     PutBall ;met la balle
 bsr     DrawScreen ; handle+decalage->ecran
 bsr     ClrBall ;on efface la balle du handle

 lea     strend(PC),a0 ;convertit le score en cha?ne...

 move.w  #2,-(a7)
 jsr     doorsos::FontSetSys
 lea     2(a7),a7

 move.w  score,d0
 move.w  #4,d1
 bsr     ConvStr
 WriteStrA #128,#91,#4,a0 ;et l'affiche

 move.w  #1,-(a7);fontes L6*H8
 jsr     doorsos::FontSetSys
 lea     2(a7),a7

 move.b  delay,d3 ;temporisation
\delay:
 cmp.b   timer,d3
 bgt     \delay
 clr.b   timer

 bsr     MoveBall ;scanne le clavier, d\Gamma\place la balle
 tst.w   d4 ;en haut de l'\Gamma\cran=>mort
 beq     MainBoucle ;pas mort => \zeta\a continue !


Done:
 bsr     GetKeyStat
 cmp.b   #$FF,keystat
 bne     Done ;attend rel\Gamma\chement des fl?ches

 move.w  #$0700,d0;remet int#1
 trap    #1
 bclr.b  #2,$600001
 move.l  oldint#1(PC),$64
 move.l  oldint#6(PC),$60+6*4
 bset.b  #2,$600001
 trap    #1
 bra     Menu

Exit:
 move.w  hnum,-(a7) ;rends la memoire
 jsr     doorsos::HeapFree
 addq    #2,a7
 rts


;*************FONCTIONS*****************;
GetKeyStat:
 movem.l d0-d1/a0,-(a7)
 lea keystat(PC),a0
 move.w  #$FFFE,d0
 moveq #6,d1
GetKeys:
 move.w  d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 move.b  $60001B,(a0)+
 rol.w #1,d0
 dbra d1,GetKeys
 movem.l (a7)+,d0-d1/a0
 rts


MoveBall:
 movem.l d2-d5,-(a7)
 move.w  x,d0
 move.w  y,d1
 move.w  d1,d3
 add.w   #bas_balle,d3
 sub.w   dy,d3
 bsr     GetKeyStat
 btst.b  #6,keystat+1
 bne     NoTeacher
 trap    #4
NoTeacher:
 bsr     InBlock
 cmp.b   #1,d4
 bne     PasBloque
 sub.w   #npix,y ;si bloqu\Gamma\, monte la balle
 tst.w   d3
 bgt     PasBloque ;non->on continue !
 movem.l (a7)+,d2-d5
 move.w  #$FF,d4 ;d4=$FF : balle sortie de l'ecran (mort)
 rts
PasBloque:
 move.w  hpix,d5
 btst.b  #1,keystat
 bne     NoLeft
 sub.w   d5,x ;on bouge
 bsr     InBlock
 cmp.b   #1,d4 ;une case \Delta\ gauche ?
 bne     NoLeft ;non=>c'est bon
 add.w   d5,x ;si=>retour \Delta\ la pos de d\Gamma\part
NoLeft:
 btst.b  #3,keystat
 bne     NoRight
 add.w   d5,x;on bouge
 bsr     InBlock
 cmp.b   #1,d4 ;une case \Delta\ droite ?
 bne     NoRight ;non=>c'est bon
 sub.w   d5,x ;si=>retour \Delta\ la pos de d\Gamma\part
NoRight:
 move.w  vpix,d5
 add.w   d5,y;on bouge
 bsr     InBlock ;case en dessous ?
 cmp.b   #1,d4
 bne     NoDown;non=>c'est bon
 sub.w   d5,y ;si=>retour \Delta\ la pos de d\Gamma\part
NoDown:
 tst.w   x
 bge     Ok_Left
 clr.w   x
Ok_Left:
 cmp.w   #149,x
 ble     Ok_Right
 move.w  #149,x
Ok_Right:
 move.w  dy,d5 ;v\Gamma\rifie si la balle sort pas en bas
 add.w   #100-bas_balle,d5
 cmp     y,d5
 bgt     Ok_Down
 move.w  d5,y
Ok_Down:

 sub.w   #5,y ;y'a t'i des bonus ?
 bsr     InBlock
 add.w   #5,y
 cmp.b   #2,d4
 bne     NoHorzSpeedBonus
 move.w  #2*npix,hpix
 move.w  #bonus_time,b1time
NoHorzSpeedBonus:
 cmp.b   #3,d4
 bne     NoVertSpeedBonus
 move.w  #4*npix,vpix
 move.w  #bonus_time,b2time
NoVertSpeedBonus:

 movem.l (a7)+,d2-d5
 clr.w   d4 ;d4=0 => pas mort
 rts



InBlock:;d4=$FF si y'a une case en (d0,d1)
 movem.l d0-d1/a0,-(a7)
 move.w  y,d1
 add.w   #bas_balle,d1
 divu    #10,d1
 mulu    #10,d1
 move.w  x,d0
 add.w   #5,d0;x+5 pour le centre de la balle
 lsr.w   #4,d0;largeur case = 2^4 pixels
 add.w   d0,d1
 lea     matrix(PC),a0
 move.b  0(a0,d1),d4
 movem.l (a7)+,d0-d1/a0
 rts



ScrollUp:
 movem.l d0-d2/a0-a2,-(a7)
 move.l  hptr,a0  ;scrolle l'\Gamma\cran de 10 lignes vers le haut
 move.l  #499,d0
RepScrollDown:
 move.l  200(a0),(a0)+
 dbra    d0,RepScrollDown

 lea     matrix(PC),a2 ;scrolle la matrice une ligne vers le haut
 move.w  #54,d0
RepScrollMat:
 move.w  10(a2),(a2)+
 dbra    d0,RepScrollMat
 clr.w   (a2)
 clr.w   2(a2)
 clr.w   4(a2)
 clr.w   6(a2)
 clr.w   8(a2)

 add.w   #1,freqfloor

 cmp.w   #3,freqfloor
 bne     NoPutBonus
 move.w  #3,d0
 jsr     userlib::random
 tst.w   d0
 bne     NoPutBonus
 move.w  #2,d0
 jsr     userlib::random
 add.w   #2,d0
 move.b  d0,d1
 move.w  #10,d0
 jsr     userlib::random
 move.b  d1,0(a2,d0)
NoPutBonus:
 cmp.w   #5,freqfloor ;4 lignes sans mur pass\Gamma\es ?
 bne     NoPutRow ;non => on n'en fait pas encore une
 clr.w   freqfloor
 bsr     CreateRow ;oui => on cr\Gamma\e la ligne
 add.w   #1,score ;score+1
NoPutRow:
 lea     matrix+100(PC),a2
 move.w  #9,d1
RepVirtualCol:
 lea     block(PC),a1
 move.b  (a2)+,d0
 and.l   #$FF,d0
 mulu    #20,d0
 adda.w  d0,a1
 move.l  a0,-(a7)
 move.w  #9,d2 ;dessine la case
RepPutRow:
 move.w  (a1)+,(a0)
 lea     20(a0),a0
 dbra    d2,RepPutRow 
 move.l  (a7)+,a0
 lea     2(a0),a0
 dbra    d1,RepVirtualCol
 movem.l (a7)+,d0-d2/a0-a2
 rts



CreateRow:
 movem.l d0-d1/a0,-(a7)
 lea     matrix+100(PC),a0
 move.w  #9,d0
RepCreateBlocs:
 move.b  #1,0(a0,d0) ;bloc=1 dans la matrice
 dbra    d0,RepCreateBlocs
 move.b  nholes,d1
 sub.b   #1,d1
RepCreateHoles:
 move.l  #10,d0 
 jsr     userlib::random ;d0=num\Gamma\ro de la case trou\Gamma\e
 clr.b   0(a0,d0) ;trou=0 dans la matrice
 dbra    d1,RepCreateHoles
 movem.l (a7)+,d0-d1/a0
 rts



DrawScreen:
 movem.l d0-d2/a0-a1,-(a7)
 move.l  hptr,a0
 move.l  #LCD_MEM,a1
 move.w  dy,d0
 mulu    #20,d0
 adda.w  d0,a0 ;a0+20*dy
 move.w  #99,d0
RepCopyLine:
 move.w  #9,d1
RepCopyWord:
 move.w  (a0)+,(a1)+
 dbra    d1,RepCopyWord
 lea     10(a1),a1 ;putain de ti89 de merde !
 dbra    d0,RepCopyLine
 movem.l (a7)+,d0-d2/a0-a1
 rts 



PutBall:
 movem.l d0-d3/a0-a2,-(a7)
 move.w  x,d0
 move.w  y,d1

 move.l  hptr,a1
 mulu    #20,d1
 adda.w  d1,a1
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 adda.w  d0,a1
 and.b   #$0F,d1
 eori.b  #%1111,d1 ;d1=d\Gamma\calage addresse longint/d\Gamma\but dessin

 lea     ball(PC),a0  ;a0 pointe sur le bon dessin de la balle
 lea     background(PC),a2
 moveq   #9,d0
RepPut:
 move.l  (a1),(a2)+ ;sauve le fond
 clr.l   d2
 clr.l   d3
 move.w  20(a0),d3 ;lit le masque
 rol.l   d1,d3
 not.l   d3
 and.l   d3,(a1) ;l'applique au fond (bit du masque \Delta\ 1=>bit fond \Delta\ 0)
 move.w  (a0)+,d2 ;dessin
 lsl.l   d1,d2
 or.l    d2,(a1)
 add.l   #20,a1
 dbra    d0,RepPut
 movem.l (a7)+,d0-d3/a0-a2
 rts



ClrBall:
 movem.l d0-d2/a0-a1,-(a7)
 move.w  x,d0
 move.w  y,d1
 lea     background(PC),a0
 move.l  hptr,a1
 mulu    #20,d1
 adda.w  d1,a1
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 adda.w  d0,a1
 and.b   #$0F,d1
 eori.b  #%1111,d1
 moveq   #9,d0
RepClr:
 move.l  (a0)+,(a1)
 add.l   #20,a1 
 dbra    d0,RepClr
 movem.l (a7)+,d0-d2/a0-a1
 rts



ConvStr:
 movem.l d0-d2,-(a7)
 clr.b   (a0)
RepConv:
 divu    #10,d0
 move.l  d0,d2
 swap    d2
 add.b   #48,d2
 move.b  d2,-(a0)
 subq    #1,d1
 and.l   #$FFFF,d0
 bne     RepConv
 tst.w   d1
 beq     CS_Done
 subq    #1,d1
FillOut:
 move.b  #32,-(a0)
 dbra    d1,FillOut
CS_Done:
 movem.l (a7)+,d0-d2
 rts



ArchiveScore:
 movem.l d0-d1/a0-a2,-(a7)
 move.w  score,d0
 lea     hiscores(PC),a2
 move.w  diff,d1
 mulu    #90,d1
 add.w   d1,a2
 cmp.w  88(a2),d0
 ble     TooLow
 lea  16(a2),a0
 moveq  #4,d1
CheckHigher:
 cmp.w  (a0),d0
 bgt     HigherFound
 lea  18(a0),a0
 dbra  d1,CheckHigher
HigherFound:
 move.w  d1,place
 lea  90(a2),a0
 lea  72(a2),a3
 tst.w  d1 ;on est le dernier ? (d1=0)
 beq     NoScrollDown ;oui=>fin
 mulu  #9,d1 ;1 score = 1 cha?ne (16 bytes)+1 word (score) = 9 words
 subq  #1,d1
ScrollDown: ;d\Gamma\place les scores vers le bas
 move.w  -(a3),-(a0)
 dbra  d1,ScrollDown
NoScrollDown:
 move.w  d0,16(a3) ;on sauve le score
 move.w  #14,d1 ;on nettoie l'emplacement pour le nom
ResetName:
 move.b  #32,0(a3,d1)
 dbra    d1,ResetName
 bsr     ShowScores ;on affiche les scores
 lea     invite(PC),a0
 WriteStrA #38,#92,#4,a0
 bsr     ReadName ;lit le nom au bon endroit et le sauve
 lea     empty(PC),a0
 WriteStrA #38,#92,#4,a0
TooLow:
 movem.l (a7)+,d0-d1/a0-a2
 rts



ReadName:
 movem.l d0-d4,-(a7)
 move.w  #20,d3 ;x
 move.w  #4,d1
 sub.w   place,d1
 lsl.w   #3,d1
 add.w   #50,d1 ;y

 move.w  #14,d0
 move.w  #18,d2
 bsr     WriteChar

 clr.w   doorsos::kb_vars+$1C
 clr.w  d4
Input:
 jsr     userlib::idle_loop
 cmp.w  #13,d0
 beq     InputDone
 cmp.w  #257,d0
 beq     BackSpace
 cmp.w   #32,d0
 bcs     Input
 cmp.w   #256,d0
 bcc     Input
 cmp.w   #15,d4
 beq     Input
 move.b  d0,(a3)+
 move.w  d0,d2
 move.w  d3,d0
 bsr     WriteChar
 addq  #6,d3
 addq  #1,d4
 bra     Input
BackSpace:
 tst.w   d4
 beq     Input
 clr.b   -(a3)
 subq    #6,d3
 move.w  d3,d0
 moveq   #32,d2
 bsr     WriteChar
 sub.w   #1,d4
 bra     Input
InputDone:
 tst.w   d4 ;cha?ne vide ?
 beq     Input ;il faut au moins 1 caract?re=>Input

 move.w  #14,d0
 move.w  #32,d2
 bsr     WriteChar

 movem.l (a7)+,d0-d4
 rts



ShowDiff:
 movem.l d0-d2/a0,-(a7)
 move.w  diff,d2
 lsl.w   #4,d2
 lea     diffmsgs(PC),a0
 adda.w  d2,a0
 WriteStrA #38,#92,#4,a0
 movem.l (a7)+,d0-d2/a0
 rts


ShowScores:
 movem.l d0-d4/a0-a2,-(a7)
 lea  hiscores(PC),a2
 move.w  diff,d1
 mulu    #90,d1
 add.w   d1,a2
 moveq  #50,d4 ;ordonn\Gamma\e de la 1?re ligne
 moveq  #4,d3
ShowNextScore:
 WriteStrA #20,d4,#4,a2
 lea     strend(PC),a0
 move.w  16(a2),d0
 moveq   #4,d1
 bsr     ConvStr
 WriteStrA #116,d4,#4,a0
 lea     18(a2),a2
 add.l   #8,d4
 dbra    d3,ShowNextScore
 movem.l (a7)+,d0-d4/a0-a2
 rts

WriteChar:
 movem.l d0-d2/a0,-(a7)
 move.w  #$00FF,-(a7)
 clr.w  -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.w  d2,-(a7)
 bsr     DrawCharXY
 lea  14(a7),a7
 movem.l (a7)+,d0-d2/a0
 rts

DrawCharXY
util@000D:
        move.w 4(a7),d0
        move.b d0,charstr
        move.w 6(a7),d0
        move.w 8(a7),d1
        move.w 10(a7),d2
        move.w d2,-(a7)
        move.l #charstr,-(a7)
        move.w d1,-(a7)
        move.w d0,-(a7)
        jsr doorsos::DrawStrXY
        add.l #10,a7
        rts


;*********** Interruptions *************;
newint#1:
 add.b   #1,timer
 sub.w   #1,b1time
 tst.w   b1time
 bne     NoReachB1
 move.w  #npix,hpix
NoReachB1:
 sub.w   #1,b2time
 tst.w   b2time
 bne     NoReachB2
 move.w  #2*npix,vpix
NoReachB2:
newint#6: ;int#6=que dalle (juste pour \Gamma\viter ralentissement)
 rte
;************ Variables ****************;
oldint#1 dc.l 0
oldint#6 dc.l 0
hptr     dc.l 0
hpix     dc.w 0
vpix     dc.w 0
diff     dc.w 2
hnum     dc.w 0
score    dc.w 0
place    dc.w 0
highscore dc.w 0
freqfloor dc.w 0 ;fr\Gamma\quence des barres
dy       dc.w 0
x        dc.w 0
y        dc.w 0
b1time   dc.w 0 ;pour les bonus : temps limit\Gamma\
b2time   dc.w 0
delay    dc.b 0
nholes   dc.b 0
timer    dc.b 0
keystat  ds.b 7
str      ds.b 16
charstr  dc.b 0
strend
background ds.l 10
matrix   ds.l 3*10

hiscores:
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

;************** Donn\Gamma\es ****************;
difftab dc.l 0
difftabHW1:
 dc.b 12,4 ;delay, trous par ligne
 dc.b 10,3
 dc.b 8,3
 dc.b 6,3
 dc.b 6,2
difftabHW2:
 dc.b 8,4 ;delay, trous par ligne
 dc.b 7,3
 dc.b 6,3
 dc.b 5,3
 dc.b 4,2
diffmsgs:
 dc.b 32," VERY  EASY ",18,0,0
 dc.b 17,"    EASY    ",18,0,0
 dc.b 17,"   NORMAL   ",18,0,0
 dc.b 17,"    HARD    ",18,0,0
 dc.b 17," IMPOSSIBLE ",32,0,0

block:
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000

 dc.w %1010101011111111
 dc.w %0101010111111111
 dc.w %1010101111111110
 dc.w %0101011111111101 
 dc.w %1010111111111010
 dc.w %0101111111110101
 dc.w %1011111111101010 
 dc.w %0111111111010101
 dc.w %1111111110101010
 dc.w %1111111101010101

 dc.w %0000000000011100
 dc.w %0000000011110000
 dc.w %0000011111000000
 dc.w %0001111100000000
 dc.w %0000011110000000
 dc.w %0000000111100000
 dc.w %0000000011111000
 dc.w %0000001111100000
 dc.w %0000111100000000
 dc.w %0011100000000000

 dc.w %0000001111000000
 dc.w %0000001111000000
 dc.w %0000000110000000
 dc.w %0000001111000000
 dc.w %0001111110111000
 dc.w %0011001110101100
 dc.w %0010110110011100
 dc.w %0011101110101100
 dc.w %0010000110110100
 dc.w %0011111111111100

ball:
 dc.w %0001111000000000
 dc.w %0111001110000000
 dc.w %0110011110000000
 dc.w %1100111111000000
 dc.w %1001111111000000
 dc.w %1111111111000000
 dc.w %1111111111000000
 dc.w %0111111110000000
 dc.w %0111111110000000
 dc.w %0001111000000000
mask:
 dc.w %0001111000000000
 dc.w %0111111110000000
 dc.w %0111111110000000
 dc.w %1111111111000000
 dc.w %1111111111000000
 dc.w %1111111111000000
 dc.w %1111111111000000
 dc.w %0111111110000000
 dc.w %0111111110000000
 dc.w %0001111000000000


title:
 INCBIN falldown.huf

invite dc.b "ENTER YOUR NAME",0
empty  dc.b "               ",0

titre dc.b "   FALLDOWN  v3.0   ",0
t1 dc.b "FallDown by Thomas Fernique ",169,"1997",0
t2 dc.b "Ported to DoorsOS II - ROM v2.0x",0
t3 dc.b "By Flavien Racine -FLASH-",0
t4 dc.b "FlashZ@netcourrier.com",0
t5 dc.b "http://www.multimania.com/flashz",0
t7 dc.b "Press any key to start...",0
_comment: dc.b "FallDown v3.0 by Thomas Fernique",0
;***************************************;
 end


