;Th.FERNIQUE <FFernique@eisti.fr>
 include "tios.h"
 include "flib.h"
 include "hufflib.h"


 xdef _main
 xdef _comment

;***************************************;
;WriteStrA MACRO
; move.w  \3,-(a7)
; move.l  \4,-(a7)
; move.w  \2,-(a7)
; move.w  \1,-(a7)
; jsr     tios::DrawStrXY
; lea     10(a7),a7
; ENDM
;***************************************;
HW_VERSION equ CALCULATOR+1
npix       equ 2
bas_balle  equ 15
bonus_time equ 3*16*4*10		;10 barres en vitesse '4' (very hard)
;***************************************;

_main:

 move.l  #difftabHW1,a0
 move.l  a0,difftab
 move.b  HW_VERSION,d0
 cmp.b   #1,d0
 beq     SkipHW2Speed
 move.l  #difftabHW2,a0
 move.l  a0,difftab
SkipHW2Speed:

 move.l  #4320,-(a7)			;place pour cran virtuel
 jsr     tios::HeapAllocThrow
 lea     4(a7),a7
 move.w  d0,hnum
 tios::DEREF d0,a0
 move.l  a0,hptr

 clr.w   score

Menu:
 jsr     flib::zap_screen
 move.w  #1,-(a7)			;fontes L6*H8
 jsr     tios::FontSetSys
 lea     2(a7),a7

 lea     title(PC),a0
 move.l  hptr,a1
 jsr     hufflib::extract
 move.l  hptr,a0
 lea     LCD_MEM+30*4+5,a1
 move.w  #59,d0
Rep1:
 move.w  #19,d1
Rep2:
 move.b  (a0)+,(a1)+
 dbra    d1,Rep2
 add.l   #10,a1
 dbra    d0,Rep1

 tst.w   score				;un score  la dernire partie ?
 beq     MenuLoop
 bsr     ArchiveScore			;oui=>on archive nom et score du joueur
MenuLoop:
 bsr     ShowScores
 bsr     ShowDiff
 jsr     flib::idle_loop
 cmp     #337,d0			;gauche=>diff-1
 bne     NoDecDiff
 cmp     #0,diff
 beq     NoDecDiff
 sub.w   #1,diff
NoDecDiff:
 cmp     #340,d0			;gauche=>diff+1
 bne     NoIncDiff
 cmp     #4,diff
 beq     NoIncDiff
 add.w   #1,diff
NoIncDiff:
 cmp     #264,d0
 beq     Exit				;esc=>quitter
 cmp     #13,d0				;enter=>dbut de partie
 bne     MenuLoop


 move.w  diff,d0
 lsl.w   #1,d0
 move.l  difftab,a0
 move.b  0(a0,d0),delay
 move.b  1(a0,d0),nholes
 move.w  #2*npix,vpix
 move.w  #npix,hpix


 clr.w   -(a7)
 jsr     tios::ST_busy
 lea     2(a7),a7


 move.w  #$0700,d0			;redirige int#1
 trap    #1
 move.l  $64,oldint#1
 move.l  $60+6*4,oldint#6		;et int#6 (ON) : viter la triche
 bclr.b  #2,$600001
 move.l  #newint#1,$64
 move.l  #newint#6,$60+6*4		;enlever cette ligne pour la capture d'cran (avec FCAMERA par exemple)
 bset.b  #2,$600001
 trap    #1

 lea     matrix(PC),a0			;nettoie la matrice
 move.w  #9*4-1,d0
\clr:
 clr.l   (a0)+
 dbra    d0,\clr

 move.l  hptr,a0			;on copie cran vers handle
 lea     LCD_MEM,a1
 move.w  #959,d0
InitHandle1:
 move.l  (a1)+,(a0)+
 dbra    d0,InitHandle1
 move.w  #119,d0
InitHandle2:
 clr.l   (a0)+
 dbra    d0,InitHandle2

 move.w  #2,-(a7)			;fontes L8*H10
 jsr     tios::FontSetSys
 lea     2(a7),a7


 move.w  #112,x	;130
 clr.w   y	;15
 clr.w   score
 clr.w   mod3				;mod3 : un mur toutes les 3 lignes
 clr.w   dy

MainBoucle:
 add.w   #npix,dy			;dcalage ecran/handle (0-15)
 add.w   #npix,y			;balle
 cmp.w   #16,dy				;dcalage=16 ?
 blt     NoNewMatrixLine
 sub.w   #16,dy				;oui=>scrolle matrice+handle d'une ligne (=16pixels)
 add.w   #1,score			;score+1
 sub.w   #16,y				;coord y balle -16
 bsr     ScrollUp
NoNewMatrixLine:
 bsr     PutBall			;met la balle
 bsr     DrawScreen			;handle+decalage->ecran

 lea     strend(PC),a0			;convertit le score en chane...
 move.w  score,d0
 move.w  #4,d1
 bsr     ConvStr
 WriteStrA #208,#118,#4,a0		;et l'affiche

 bsr     ClrBall			;on efface la balle du handle

 move.b  delay,d3			;ralentit pour ti92II ou calc boostes
\delay:
 cmp.b   timer,d3
 bgt     \delay
 clr.b   timer

 bsr     MoveBall			;scanne le clavier, dplace la balle
; btst.b  #6,keystat+8			;ESC ?
; bne     NoEsc
; clr.w   score
; bra     Done
;NoEsc:
 tst.w   d4				;en haut de l'cran=>mort
 beq     MainBoucle			;pas mort => a continue !


Done:
 bsr     GetKeyStat
 cmp.b   #$FF,keystat
 bne     Done				;attend relchement des flches

 move.w  #$0700,d0			;remet int#1
 trap    #1
 bclr.b  #2,$600001
 move.l  oldint#1(PC),$64
 move.l  oldint#6(PC),$60+6*4
 bset.b  #2,$600001
 trap    #1
 bra     Menu

Exit:
 move.w  hnum,-(a7)			;rends la memoire
 jsr     tios::HeapFree
 addq    #2,a7
 rts


;*************FONCTIONS*****************;
GetKeyStat:
 movem.l d0-d1/a0,-(a7)
 lea	 keystat(PC),a0
 move.w  #$FFFE,d0
 moveq	 #9,d1
GetKeys:
 move.w  d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 nop
 move.b  $60001B,(a0)+
 rol.w	 #1,d0
 dbra	 d1,GetKeys
 movem.l (a7)+,d0-d1/a0
 rts


MoveBall:
 movem.l d2-d5,-(a7)
 move.w  x,d0
 move.w  y,d1
 move.w  d1,d3
 add.w   #bas_balle,d3
 sub.w   dy,d3
 bsr     GetKeyStat
; btst.b  #3,keystat	;triche :)
; beq     PasBloque	;
 bsr     InBlock
 cmp.b   #1,d4
 bne     PasBloque
 sub.w   #npix,y			;si bloqu, monte la balle
 tst.w   d3				;mort ?
 bgt     PasBloque			;non->on continue !
 movem.l (a7)+,d2-d5
 move.w  #$FF,d4			;d4=$FF : balle sortie de l'ecran (mort)
 rts
PasBloque:
 move.w  hpix,d5
 btst.b  #4,keystat
 bne     NoLeft
 sub.w   d5,x				;on bouge
 bsr     InBlock
 cmp.b   #1,d4				;une case  gauche ?
 bne     NoLeft				;non=>c'est bon
 add.w   d5,x				;si=>retour  la pos de dpart
NoLeft:
 btst.b  #6,keystat
 bne     NoRight
 add.w   d5,x				;on bouge
 bsr     InBlock
 cmp.b   #1,d4				;une case  droite ?
 bne     NoRight			;non=>c'est bon
 sub.w   d5,x				;si=>retour  la pos de dpart
NoRight:
 move.w  vpix,d5
 add.w   d5,y				;on bouge
 bsr     InBlock			;case en dessous ?
 cmp.b   #1,d4
 bne     NoDown				;non=>c'est bon
 sub.w   d5,y				;si=>retour  la pos de dpart
NoDown:


 tst.w   x
 bge     Ok_Left
 clr.w   x
Ok_Left:
 cmp.w   #224,x
 ble     Ok_Right
 move.w  #224,x
Ok_Right:
 move.w  dy,d5				;vrifie si la balle sort pas en bas
 add.w   #128-bas_balle,d5
 cmp     y,d5
 bgt     Ok_Down
 move.w  d5,y
Ok_Down:

 sub.w   #8,y				;y'a t'i des bonus ?
 bsr     InBlock
 add.w   #8,y
 cmp.b   #2,d4
 bne     NoHorzSpeedBonus
 move.w  #2*npix,hpix
 move.w  #bonus_time,b1time
NoHorzSpeedBonus:
 cmp.b   #3,d4
 bne     NoVertSpeedBonus
 move.w  #4*npix,vpix
 move.w  #bonus_time,b2time
NoVertSpeedBonus:

 movem.l (a7)+,d2-d5
 clr.w   d4				;d4=0 => pas mort
 rts



InBlock:				;d4=$FF si y'a une case en (d0,d1)
 movem.l d0-d1/a0,-(a7)
 move.w  y,d1
 add.w   #bas_balle,d1
 and.w   #$FFF0,d1
 move.w  x,d0
 add.w   #8,d0				;x+8 pour le centre de la balle
 lsr.w   #4,d0				;largeur case = 2^4 pixels
 add.w   d0,d1
 lea     matrix(PC),a0
 move.b  0(a0,d1),d4
 movem.l (a7)+,d0-d1/a0
 rts



ScrollUp:
 movem.l d0-d2/a0-a2,-(a7)
 move.l  hptr,a0			;scrolle l'cran de 16 lignes vers le haut
 move.l  #959,d0
RepScrollDown:
 move.l  480(a0),(a0)+
 dbra    d0,RepScrollDown


 lea     matrix(PC),a2			;scrolle la matrice une ligne vers le haut
 move.w  #4*8-1,d0
RepScrollMat:
 move.l  16(a2),(a2)+
 dbra    d0,RepScrollMat
 clr.l   12(a2)
 clr.l   8(a2)
 clr.l   4(a2)
 clr.l   (a2)

 add.w   #1,mod3

 cmp     #2,mod3
 bne     NoPutBonus
 move.w  #3,d0
 jsr     flib::random
 tst.w   d0
 bne     NoPutBonus
 move.w  #2,d0
 jsr     flib::random
 add.w   #2,d0
 move.b  d0,d1
 move.w  #15,d0
 jsr     flib::random
 move.b  d1,0(a2,d0)
NoPutBonus:
 cmp     #3,mod3			;2 lignes sans mur passes ?
 bne     NoPutRow			;non => on en fait pas encore une
 clr.w   mod3
 bsr     CreateRow			;oui => on cre la ligne
NoPutRow:

 lea     matrix+16*8(PC),a2
 move.w  #14,d1
RepVirtualCol:
 lea     block(PC),a1
 move.b  (a2)+,d0
 and.w   #$FF,d0
 lsl.w   #5,d0
 adda.w  d0,a1

 move.l  a0,-(a7)
 move.w  #15,d2				;dessine la case
RepPutRow:
 move.w  (a1)+,(a0)
 add.l   #30,a0
 dbra    d2,RepPutRow 
 move.l  (a7)+,a0

 add.l   #2,a0
 dbra    d1,RepVirtualCol

 movem.l (a7)+,d0-d2/a0-a2
 rts



CreateRow:
 movem.l d0-d1/a0,-(a7)
 lea     matrix+16*8(PC),a0

 move.w  #15,d0
RepCreateBlocs:
 move.b  #1,0(a0,d0)			;bloc=1 dans la matrice
 dbra    d0,RepCreateBlocs

 move.b  nholes,d1
 sub.b   #1,d1
RepCreateHoles:
 move.l  #15,d0				
 jsr     flib::random			;d0=numro de la case troue
 clr.b   0(a0,d0)			;trou=0 dans la matrice
 dbra    d1,RepCreateHoles

 movem.l (a7)+,d0-d1/a0
 rts



DrawScreen:
 movem.l d0-d2/a0-a1,-(a7)
 move.l  hptr,a0
 move.l  #LCD_MEM,a1
 move.w  dy,d0
 lsl.w   #1,d0
 move.w  d0,d1
 lsl.w   #4,d1
 sub.w   d0,d1
 adda.w  d1,a0				;a0+30*dy
 move.l  #959,d0
RepCopy:
 move.l  (a0)+,(a1)+
 dbra    d0,RepCopy
 movem.l (a7)+,d0-d2/a0-a1
 rts 



PutBall:
 movem.l d0-d3/a0-a2,-(a7)
 move.w  x,d0
 move.w  y,d1

 lsl.w   #1,d1				;a1=addresse du handle ou commence dessin (multiple de 4)
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1			;d1=dcalage addresse longint/dbut dessin
 move.l  hptr,a1
 adda.l  d2,a1

 lea     ball(PC),a0			;a0 pointe sur le bon dessin de la balle
 lea     background(PC),a2
 moveq   #15,d0
RepPut:
 move.l  (a1),(a2)+			;sauve le fond
 clr.l   d2
 clr.l   d3
 move.w  32(a0),d3			;lit le masque
 rol.l   d1,d3
 not.l   d3
 and.l   d3,(a1)			;l'applique au fond (bit du masque  1=>bit fond  0)
 move.w  (a0)+,d2			;dessin
 lsl.l   d1,d2
 or.l    d2,(a1)
 add.l   #30,a1
 dbra    d0,RepPut
 movem.l (a7)+,d0-d3/a0-a2
 rts



ClrBall:
 movem.l d0-d2/a0-a1,-(a7)
 move.w  x,d0
 move.w  y,d1
 lea     background(PC),a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 eori.b  #%1111,d1
 move.l  hptr,a1
 adda.l  d2,a1
 moveq   #15,d0
RepClr:
 move.l  (a0)+,(a1)
 add.l   #30,a1 
 dbra    d0,RepClr
 movem.l (a7)+,d0-d2/a0-a1
 rts



ConvStr:
 movem.l d0-d2,-(a7)
 clr.b   (a0)
RepConv:
 divu    #10,d0
 move.l  d0,d2
 swap    d2
 add.b   #48,d2
 move.b  d2,-(a0)
 subq    #1,d1
 and.l   #$FFFF,d0
 bne     RepConv
 tst.w   d1
 beq     CS_Done
 subq    #1,d1
FillOut:
 move.b  #32,-(a0)
 dbra    d1,FillOut
CS_Done:
 movem.l (a7)+,d0-d2
 rts



ArchiveScore:
 movem.l d0-d1/a0-a3,-(a7)
 move.w  score,d0
 lea     hiscores(PC),a2
 move.w  diff,d1
 mulu    #90,d1
 add.w   d1,a2
 cmp.w	 88(a2),d0
 ble     TooLow
 lea	 16(a2),a3
 moveq	 #4,d1
CheckHigher:
 cmp.w	 (a3),d0
 bgt     HigherFound
 lea	 18(a3),a3
 dbra	 d1,CheckHigher
HigherFound:
 move.w  d1,place
 lea	 90(a2),a3
 lea	 72(a2),a4
 tst.w	 d1				;on est le dernier ? (d1=0)
 beq     NoScrollDown			;oui=>fin
 mulu	 #9,d1				;1 score = 1 chane (16 bytes)+1 word (score) = 9 words
 subq	 #1,d1
ScrollDown:				;dplace les scores vers le bas
 move.w  -(a4),-(a3)
 dbra	 d1,ScrollDown
NoScrollDown:
 move.w  d0,16(a4)			;on sauve le score
 move.w  #14,d1				;on nettoie l'emplacement pour le nom
ResetName:
 move.b  #32,0(a4,d1)
 dbra    d1,ResetName
 bsr     ShowScores			;on affiche les scores
 lea     invite(PC),a3
 WriteStrA #75,#120,#4,a3
 bsr     ReadName			;lit le nom au bon endroit et le sauve
 lea     empty(PC),a3
 WriteStrA #75,#120,#4,a3
TooLow:
 movem.l (a7)+,d0-d1/a0-a3
 rts



ReadName:
 movem.l d0-d4,-(a7)
 move.w  #61,d3 ;x
 move.w  #4,d1
 sub.w   place,d1
 lsl.w   #3,d1
 add.w   #68,d1 ;y

 move.w  #53,d0
 move.w  #18,d2
 bsr     WriteChar

 clr.w   tios::kb_vars+$1C
 clr.w	 d4
Input:
 jsr     flib::idle_loop
 cmp.w	 #13,d0
 beq     InputDone
 cmp.w	 #257,d0
 beq     BackSpace
 cmp.w   #32,d0
 bcs     Input
 cmp.w   #256,d0
 bcc     Input
 cmp.w   #15,d4
 beq     Input
 move.b  d0,(a4)+
 move.w  d0,d2
 move.w  d3,d0
 bsr     WriteChar
 addq	 #6,d3
 addq	 #1,d4
 bra     Input
BackSpace:
 tst.w   d4
 beq     Input
 clr.b   -(a4)
 subq    #6,d3
 move.w  d3,d0
 moveq   #32,d2
 bsr     WriteChar
 sub.w   #1,d4
 bra     Input
InputDone:
 tst.w   d4				;chane vide ?
 beq     Input				;il faut au moins 1 caractre=>Input

 move.w  #53,d0
 move.w  #32,d2
 bsr     WriteChar

 movem.l (a7)+,d0-d4
 rts



ShowDiff:
 movem.l d0-d2/a0,-(a7)
 move.w  diff,d2
 lsl.w   #4,d2
 lea     diffmsgs(PC),a0
 adda.w  d2,a0
 WriteStrA #78,#120,#4,a0
 movem.l (a7)+,d0-d2/a0
 rts


ShowScores:
 movem.l d0-d4/a0-a2,-(a7)
 lea	 hiscores(PC),a2
 move.w  diff,d1
 mulu    #90,d1
 add.w   d1,a2
 moveq	 #68,d4				;ordonne de la 1re ligne
 moveq	 #4,d3
ShowNextScore:
 WriteStrA #61,d4,#4,a2
 lea     strend(PC),a0
 move.w  16(a2),d0
 moveq   #4,d1
 bsr     ConvStr
 WriteStrA #155,d4,#4,a0
 lea     18(a2),a2
 add.l   #8,d4
 dbra    d3,ShowNextScore
 movem.l (a7)+,d0-d4/a0-a2
 rts

WriteChar:
 movem.l d0-d2/a0-a3,-(a7)
 move.w  #$00FF,-(a7)
 clr.w	 -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.w  d2,-(a7)
 jsr     tios::DrawCharXY
 lea	 14(a7),a7
 movem.l (a7)+,d0-d2/a0-a3
 rts

;*********** Interruptions *************;
newint#1:
 add.b   #1,timer
 sub.w   #1,b1time
 tst.w   b1time
 bne     NoReachB1
 move.w  #npix,hpix
NoReachB1:
 sub.w   #1,b2time
 tst.w   b2time
 bne     NoReachB2
 move.w  #2*npix,vpix
NoReachB2:
newint#6:				;int#6=que dalle (juste pour viter ralentissement)
 rte
;************ Variables ****************;
oldint#1 dc.l 0
oldint#6 dc.l 0
hptr     dc.l 0
hpix     dc.w 0
vpix     dc.w 0
diff     dc.w 2
hnum     dc.w 0
score    dc.w 0
place    dc.w 0
highscore dc.w 0
mod3     dc.w 0  ;pour mettre un mur toutes les 3 cases (verticalement)
dy       dc.w 0
x        dc.w 0
y        dc.w 0
b1time   dc.w 0				;pour les bonus : temps limit
b2time   dc.w 0
delay    dc.b 0
nholes   dc.b 0
timer    dc.b 0
str      ds.b 16
strend
keystat  ds.b 10
matrix   ds.l 4*9
background ds.l 16

difftab	dc.l 0

difftabHW1:
 dc.b 9,4	;delay, trous par ligne
 dc.b 7,4
 dc.b 7,3
 dc.b 5,3
 dc.b 4,3

difftabHW2:
 dc.b 6,4	;delay, trous par ligne
 dc.b 5,4
 dc.b 4,3
 dc.b 3,3
 dc.b 3,2

diffmsgs:
 dc.b 32," VERY  EASY ",18,0,0
 dc.b 17,"    EASY    ",18,0,0
 dc.b 17,"   MEDIUM   ",18,0,0
 dc.b 17,"    HARD    ",18,0,0
 dc.b 17," VERY  HARD ",32,0,0

invite dc.b "ENTER YOUR NAME",0
empty  dc.b "               ",0
 EVEN
hiscores:
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0

 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0
 dc.b "...            ",0,0,0


block:
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000

 dc.w %0111111111111100
 dc.w %1000000000000010
 dc.w %1011111111111110
 dc.w %1011111111111110
 dc.w %1011111111111110
 dc.w %1011111111111110
 dc.w %1011111111111110
 dc.w %1011111111111110
 dc.w %0111111111111100
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000

 dc.w %0000000000000011
 dc.w %0000000000001110
 dc.w %0000000000111000
 dc.w %0000000011110000
 dc.w %0000001111100000
 dc.w %0000111110000000
 dc.w %0000011100000000
 dc.w %0000001110000000
 dc.w %0000000111000000
 dc.w %0000000011100000
 dc.w %0000000111110000
 dc.w %0000011111000000
 dc.w %0000111100000000
 dc.w %0001110000000000
 dc.w %0111000000000000
 dc.w %1100000000000000

 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000000000000000
 dc.w %0000001111000000
 dc.w %0000001111000000
 dc.w %0000000110000000
 dc.w %0000001111000000
 dc.w %1111111111111111
 dc.w %1111111111111111
 dc.w %1110111011111111
 dc.w %1101010101011111
 dc.w %1111010101001111
 dc.w %1110110101010011
 dc.w %1100011011000011
 dc.w %1111111111111011
 dc.w %1111111111110011

ball:
 dc.w %0000000000000000
 dc.w %0000001111000000
 dc.w %0000111111110000
 dc.w %0001100111111000
 dc.w %0011000111111100
 dc.w %0011001111111100
 dc.w %0111111111111110
 dc.w %0111111111111110
 dc.w %0111111111111110
 dc.w %0111111111111110
 dc.w %0011111111111100
 dc.w %0011111111111100
 dc.w %0001111111111000
 dc.w %0000111111110000
 dc.w %0000001111000000
 dc.w %0000000000000000
mask:
 dc.w %0000001111000000
 dc.w %0000111111110000
 dc.w %0001111111111000
 dc.w %0011111111111100
 dc.w %0111111111111110
 dc.w %0111111111111110
 dc.w %1111111111111111
 dc.w %1111111111111111
 dc.w %1111111111111111
 dc.w %1111111111111111
 dc.w %0111111111111110
 dc.w %0111111111111110
 dc.w %0011111111111100
 dc.w %0001111111111000
 dc.w %0000111111110000
 dc.w %0000001111000000



title:
 INCBIN falldown.huf

_comment: dc.b "FallDown version 2.2",0
;***************************************;
 end